/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package menadzer_v2;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.jms.ConnectionFactory;
import javax.jms.JMSConsumer;
import javax.jms.JMSContext;
import javax.jms.JMSException;
import javax.jms.JMSProducer;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.TextMessage;
import javax.jms.Topic;
import zadaci.Zadatak;

/**
 *
 * @author tasha
 */
public class Main {
    @Resource(lookup = "ZadatakQueue")
    static Queue queue;
    
    @Resource(lookup = "ZadatakTopic")
    static Topic topic;
    
    @Resource(lookup = "jms/__defaultConnectionFactory")
    static ConnectionFactory connectionFactory;
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        JMSContext context = connectionFactory.createContext();
        JMSProducer producer = context.createProducer();
        JMSConsumer consumer = context.createConsumer(queue);
        consumer.setMessageListener((Message msg) -> {
            try {
                TextMessage txtMsg=(TextMessage)msg;
                String odg=txtMsg.getText();
                int IdR=txtMsg.getIntProperty("IdR");
                System.out.println("Dobili odg od radnika "+IdR+": "+odg );
            } catch (JMSException ex) {
                Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
            }
        });
       
        for(int i=0; i<10000; i++){
            try {
                int sekunde = (int)(Math.random() * 6 + 5);
                Thread.sleep(sekunde*1000);
                
                int op = (int)(Math.random() * 3);
                int a = (int)(Math.random() * 101);
                int b = (int)(Math.random() * 101);
                int idR = (int)(Math.random() * 3+1);
                
                Zadatak zadatak = new Zadatak(a,b);
                zadatak.setOperacija(op);
                
                String imeZadatka = "Zadatak" + i + " (a = " + a + ", b = " + b + ", operacija: " + zadatak.getNazivOperacija() + ")";
                
                ObjectMessage objMsg=context.createObjectMessage(zadatak);
                objMsg.setIntProperty("IdR", idR);
                objMsg.setStringProperty("Naziv", imeZadatka);
                producer.send(topic, objMsg);
                System.out.println("Poslat je zadatak '" + imeZadatka + "' radniku " + idR);
            } catch (InterruptedException ex) {
                Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
            } catch (JMSException ex) {
                Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
            }
                
        }
    }
    
}
